"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
from airbyte_api import utils
from dataclasses_json import Undefined, dataclass_json
from enum import Enum
from typing import Final, Optional


class Plausible(str, Enum):
    PLAUSIBLE = 'plausible'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SourcePlausible:
    api_key: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('api_key') }})
    r"""Plausible API Key. See the <a href=\\"https://plausible.io/docs/stats-api\\">docs</a> for information on how to generate this key."""
    site_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('site_id') }})
    r"""The domain of the site you want to retrieve data for. Enter the name of your site as configured on Plausible, i.e., excluding \\"https://\\" and \\"www\\". Can be retrieved from the 'domain' field in your Plausible site settings."""
    api_url: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('api_url'), 'exclude': lambda f: f is None }})
    r"""The API URL of your plausible instance. Change this if you self-host plausible. The default is https://plausible.io/api/v1/stats"""
    SOURCE_TYPE: Final[Plausible] = dataclasses.field(default=Plausible.PLAUSIBLE, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('sourceType') }})
    start_date: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('start_date'), 'exclude': lambda f: f is None }})
    r"""Start date for data to retrieve, in ISO-8601 format."""
    

