"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import dateutil.parser
from airbyte_api import utils
from dataclasses_json import Undefined, dataclass_json
from datetime import datetime
from enum import Enum
from typing import Final, Optional


class Domain(str, Enum):
    r"""The domain suffix for the Zoho Inventory API based on your data center location (e.g., 'com', 'eu', 'in', etc.)"""
    COM = 'com'
    IN = 'in'
    JP = 'jp'
    EU = 'eu'
    COM_AU = 'com.au'
    CA = 'ca'
    COM_CN = 'com.cn'
    SA = 'sa'


class ZohoInventory(str, Enum):
    ZOHO_INVENTORY = 'zoho-inventory'


@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class SourceZohoInventory:
    client_id: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_id') }})
    client_secret: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('client_secret') }})
    refresh_token: str = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('refresh_token') }})
    start_date: datetime = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('start_date'), 'encoder': utils.datetimeisoformat(False), 'decoder': dateutil.parser.isoparse }})
    domain: Optional[Domain] = dataclasses.field(default=Domain.COM, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('domain'), 'exclude': lambda f: f is None }})
    r"""The domain suffix for the Zoho Inventory API based on your data center location (e.g., 'com', 'eu', 'in', etc.)"""
    SOURCE_TYPE: Final[ZohoInventory] = dataclasses.field(default=ZohoInventory.ZOHO_INVENTORY, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('sourceType') }})
    

